%define momorel 4
%define __libtoolize :
# Do we want LDAP support - Default: no
%define rlm_ldap 1

# Do we want MySQL support - Default: no
%define rlm_sql_mysql 1

# Do we want PostgreSQL support - Default: no
%define rlm_sql_pgsql 1

# Do we want unixODBC support - Default: no
%define rlm_unixodbc 1

# Where do we want all of the configuration files to go
%define raddbdir %{_sysconfdir}/raddb

# # Where init scripts live
# %%define _initscriptdir /etc/rc.d/init.d

# Options for LDAP support
# enabled via rpm -ba --define 'ldap 1'
%{?ldap:%define rlm_ldap 1}

# Options for MySQL support
# enabled via rpm -ba --define 'mysql 1'
%{?mysql:%define rlm_sql_mysql 1}

# Options for PostgreSQL support
# enabled via rpm -ba --define 'pgsql 1'
%{?pgsql:%define rlm_sql_pgsql 1}

# Options for unixODBC support
# enabled via rpm -ba --define 'unixodbc 1'
%{?unixodbc:%define rlm_unixodbc 1}

Summary: FreeRADIUS Authentication, Authorization and Accounting Server
Name: freeradius
Version: 0.9.3
Release: %{momorel}m
Group: System Environment/Daemons
License: GPL
# Packager: Shawn K. O'Shea <pkg@eth0.net>
URL: http://www.freeradius.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%NoSource 0 ftp://ftp.freeradius.org/pub/radius/%{name}-%{version}.tar.gz 36f33d9dd305a2c9f1089c30a9fff0b8
Source1: radiusd.initscript
Source2: radiusd.logrotate
Source3: radiusd.pam
Source4: freeradius.README.rpm
Patch0: freeradius-0.8.patch
Patch1: freeradius-0.9.1-gdbm_compat.patch
Provides: radiusserver
# rlm_counter, rlm_dbm, and rlm_ldap all use dbm
# rlm_x99_token need openssl. May break this out later
Prereq: chkconfig, initscripts
Requires: pam, libtool
Requires: gdbm, openssl
BuildPreReq: gdbm-devel, pam-devel, openssl-devel
BuildPrereq: krb5-devel
BuildConflicts: db2-devel

%description
FreeRADIUS Server or freeradius is a daemon for un*x operating
systems which allows one to set up (guess what!) a radius protocol server, 
which is usually used for authentication and accounting of dial-up users. 
To use server, you also need a correctly setup client which will talk to it, 
usually a terminal server or a PC with appropriate [software] which emulates it 
(PortSlave, radiusclient etc). [ed: quoted from FreeRADIUS FAQ]

%package ldap
Summary: LDAP Authorizaion and Authenication Module for FreeRADIUS
Group: System Environment/Daemons
Requires: freeradius = %{version}
Requires: openldap, openssl, cyrus-sasl, gdbm
BuildPreReq: cyrus-sasl-devel
Requires: pam
%if %{rlm_ldap}
BuildPreReq: openldap-devel, openssl-devel, gdbm-devel, pam-devel
%endif

%description ldap
This package contains the LDAP Authorization and Authentication module for FreeRADIUS.

%package mysql
Summary: MySQL Authorizaion, Authenication, and Accounting Module for FreeRADIUS
Group: System Environment/Daemons
Requires: freeradius = %{version}
Requires: MySQL
%if %{rlm_sql_mysql}
BuildPreReq: MySQL-devel
%endif

%description mysql
This package contains the MySQL Authorization, Authentication, and Accounting module for FreeRADIUS.

%package pgsql
Summary: PostgreSQL Authorizaion, Authenication, and Accounting Module for FreeRADIUS
Group: System Environment/Daemons
Requires: freeradius = %{version}
Requires: postgresql
%if %{rlm_sql_pgsql}
BuildPreReq: postgresql-devel
%endif

%description pgsql
This package contains the PostgreSQL Authorization, Authentication, and Accounting module for FreeRADIUS.

%package unixodbc
Summary: unixODBC Authorizaion, Authenication, and Accounting Module for FreeRADIUS
Group: System Environment/Daemons
Requires: freeradius = %{version}
Requires: unixODBC
%if %{rlm_unixodbc}
BuildPreReq: unixODBC-devel
%endif

%description unixodbc
This package contains the unixODBC Authorization, Authentication, and Accounting module for FreeRADIUS.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
cp aclocal.m4 src/modules/rlm_dbm/
pushd src/modules/rlm_dbm/
autoconf-2.13
popd
perl -p -i -e "s|des_cbc_encrypt|DES_cbc_encrypt|" src/modules/rlm_x99_token/*
perl -p -i -e "s| ks,| &ks,|" src/modules/rlm_x99_token/x99_mac.c
pushd src/modules/rlm_krb5
grep -v com_err\.h rlm_krb5.c > rlm_krb5.c.n
mv rlm_krb5.c.n rlm_krb5.c
popd

%build
# Mandrake uses /var/lib for _localstatedir, and putting a log and run in there
# is silly, so I use _var variable instead
%define _localstatedir %{_var}
%configure \
	--localstatedir=%{_localstatedir}
	
%make

%install
rm -rf %{buildroot}
make R="%{buildroot}" install
mkdir -p %{buildroot}/%{_initscriptdir}
mkdir -p %{buildroot}/etc/{logrotate.d,pam.d}
install -m755 %{SOURCE1} %{buildroot}%{_initscriptdir}/radiusd
install -m644 %{SOURCE2} %{buildroot}/etc/logrotate.d/radiusd
install -m644 %{SOURCE3} %{buildroot}/etc/pam.d/radius
install -m644 %{SOURCE4} ./README.rpm

# remove unwanted rc.radiusd
rm -f %{buildroot}%{_prefix}/sbin/rc.radiusd

%clean
rm -rf %{buildroot}

%post
/sbin/chkconfig --add radiusd

%preun
if [ $1 = 0 ]; then
   /sbin/service radiusd stop > /dev/null 2>&1
   /sbin/chkconfig --del radiusd
fi

%files
%defattr(-,root,root)

# Init script
%attr(755,root,root) %config %{_initscriptdir}/radiusd
%config (noreplace) /etc/pam.d/radius
%config (noreplace) /etc/logrotate.d/radiusd

%{_sbindir}/radiusd
%{_bindir}/radwho
%{_bindir}/radzap
%{_bindir}/radlast
%{_bindir}/radclient
%{_bindir}/radrelay
%{_bindir}/radtest

%attr(0755,root,root)   %dir %{_localstatedir}/log/radius
%attr(0755,root,root)   %dir %{_localstatedir}/log/radius/radacct
%attr(0755,root,root)   %dir %{_localstatedir}/run/radiusd

# dictionary
%{_datadir}/freeradius

# libtdl
##%attr(0644,root,root)	%{_includedir}/ltdl.h
##%attr(0755,root,root) %{_libdir}/libltdl*.la
##%attr(0755,root,root) %{_libdir}/libltdl*so*
##%attr(0644,root,root) %{_libdir}/libltdl.a

# libradius
%attr(0755,root,root) %{_libdir}/libradius*.la
%attr(0755,root,root) %{_libdir}/libradius*so*
%attr(0644,root,root) %{_libdir}/libradius.a

%doc COPYRIGHT CREDITS INSTALL LICENSE README
%doc doc
%doc README.rpm

%{_sbindir}/checkrad
# This rpm includes it's own init script written by the package maitainer
# %{_sbindir}/rc.radiusd
%{_sbindir}/radwatch
%{_sbindir}/check-radiusd-config

%{_mandir}/man1/radclient.1*
%{_mandir}/man1/radlast.1*
%{_mandir}/man1/radtest.1*
%{_mandir}/man1/radwho.1*
%{_mandir}/man1/radzap.1*

%{_mandir}/man5/acct_users.5*
%{_mandir}/man5/clients.5*
%{_mandir}/man5/dictionary.5*
%{_mandir}/man5/naslist.5*
%{_mandir}/man5/radiusd.conf.5*
%{_mandir}/man5/users.5*

%{_mandir}/man8/radiusd.8*
%{_mandir}/man8/radrelay.8*
%{_mandir}/man8/radwatch.8*
%{_mandir}/man8/rlm_ippool_tool.8*

# You could do the entire raddb dir, but I figured the dictionaries should
# always be replaced with the new versions, so I broke this out into a list
# of all raddb files.
%attr(0755,root,root)   %dir %{raddbdir}
%config(noreplace) %{raddbdir}/acct_users
%config(noreplace) %{raddbdir}/attrs
%config(noreplace) %{raddbdir}/clients
%config(noreplace) %{raddbdir}/clients.conf
%config(noreplace) %{raddbdir}/dictionary
%config(noreplace) %{raddbdir}/experimental.conf
%config(noreplace) %{raddbdir}/hints
%config(noreplace) %{raddbdir}/huntgroups
%config(noreplace) %{raddbdir}/ldap.attrmap
%config(noreplace) %{raddbdir}/mssql.conf
%config(noreplace) %{raddbdir}/naslist
%config(noreplace) %{raddbdir}/naspasswd
%config(noreplace) %{raddbdir}/oraclesql.conf
%config(noreplace) %{raddbdir}/postgresql.conf
%config(noreplace) %{raddbdir}/preproxy_users
%config(noreplace) %{raddbdir}/proxy.conf
%config(noreplace) %{raddbdir}/radiusd.conf
%config(noreplace) %{raddbdir}/realms
%config(noreplace) %{raddbdir}/snmp.conf
%config(noreplace) %{raddbdir}/sql.conf
%config(noreplace) %{raddbdir}/users
%config(noreplace) %{raddbdir}/x99.conf
%config(noreplace) %{raddbdir}/x99passwd.sample

# Modules
# rlm_acct_unique
%attr(0755,root,root) %{_libdir}/rlm_acct_unique*.la
%attr(0755,root,root) %{_libdir}/rlm_acct_unique*so*
%attr(0644,root,root) %{_libdir}/rlm_acct_unique.a

# rlm_always
%attr(0755,root,root) %{_libdir}/rlm_always*.la
%attr(0755,root,root) %{_libdir}/rlm_always*so*
%attr(0644,root,root) %{_libdir}/rlm_always.a

# rlm_attr_filter
%attr(0755,root,root) %{_libdir}/rlm_attr_filter*.la
%attr(0755,root,root) %{_libdir}/rlm_attr_filter*so*
%attr(0644,root,root) %{_libdir}/rlm_attr_filter.a

# rlm_attr_rewrite
%attr(0755,root,root) %{_libdir}/rlm_attr_rewrite*.la
%attr(0755,root,root) %{_libdir}/rlm_attr_rewrite*so*
%attr(0644,root,root) %{_libdir}/rlm_attr_rewrite.a

# rlm_chap
%attr(0755,root,root) %{_libdir}/rlm_chap*.la
%attr(0755,root,root) %{_libdir}/rlm_chap*so*
%attr(0644,root,root) %{_libdir}/rlm_chap.a

# rlm_counter
%attr(0755,root,root) %{_libdir}/rlm_counter*.la
%attr(0755,root,root) %{_libdir}/rlm_counter*so*
%attr(0644,root,root) %{_libdir}/rlm_counter.a

# rlm_dbm
%attr(0755,root,root) %{_libdir}/rlm_dbm*.la
%attr(0755,root,root) %{_libdir}/rlm_dbm*so*
%attr(0644,root,root) %{_libdir}/rlm_dbm.a

# Binaries
%attr(0755,root,root) %{_bindir}/rlm_dbm_parser
%attr(0755,root,root) %{_bindir}/rlm_dbm_cat

# rlm_detail
%attr(0755,root,root) %{_libdir}/rlm_detail*.la
%attr(0755,root,root) %{_libdir}/rlm_detail*so*
%attr(0644,root,root) %{_libdir}/rlm_detail.a

# rlm_eap & rlm_eap_md5 & rlm_eap_tls
%attr(0755,root,root) %{_libdir}/rlm_eap*.la
%attr(0755,root,root) %{_libdir}/rlm_eap*so*
%attr(0644,root,root) %{_libdir}/rlm_eap*.a

# rlm_fastusers
%attr(0755,root,root) %{_libdir}/rlm_fastusers*.la
%attr(0755,root,root) %{_libdir}/rlm_fastusers*so*
%attr(0644,root,root) %{_libdir}/rlm_fastusers.a

# rlm_files
%attr(0755,root,root) %{_libdir}/rlm_files*.la
%attr(0755,root,root) %{_libdir}/rlm_files*so*
%attr(0644,root,root) %{_libdir}/rlm_files.a

# rlm_digest
%attr(0644,root,root) %{_libdir}/rlm_digest*.la
%attr(0644,root,root) %{_libdir}/rlm_digest*so*
%attr(0644,root,root) %{_libdir}/rlm_digest.a

# rlm_exec
%attr(0644,root,root) %{_libdir}/rlm_exec*.la
%attr(0644,root,root) %{_libdir}/rlm_exec*so*
%attr(0644,root,root) %{_libdir}/rlm_exec.a

# rlm_expr
%attr(0644,root,root) %{_libdir}/rlm_expr*.la
%attr(0644,root,root) %{_libdir}/rlm_expr*so*
%attr(0644,root,root) %{_libdir}/rlm_expr.a

# rlm_ippool
%attr(0644,root,root) %{_libdir}/rlm_ippool*.la
%attr(0644,root,root) %{_libdir}/rlm_ippool*so*
%attr(0644,root,root) %{_libdir}/rlm_ippool.a
%attr(0755,root,root) %{_bindir}/rlm_ippool_tool

# rlm_krb5
%attr(0644,root,root) %{_libdir}/rlm_krb5*.la
%attr(0644,root,root) %{_libdir}/rlm_krb5*so*
%attr(0644,root,root) %{_libdir}/rlm_krb5.a

# rlm_mschap
%attr(0755,root,root) %{_libdir}/rlm_mschap*.la
%attr(0755,root,root) %{_libdir}/rlm_mschap*so*
%attr(0644,root,root) %{_libdir}/rlm_mschap.a
%attr(0755,root,root) %{_bindir}/smbencrypt

# rlm_ns_mta_md5
%attr(0755,root,root) %{_libdir}/rlm_ns_mta_md5*.la
%attr(0755,root,root) %{_libdir}/rlm_ns_mta_md5*so*
%attr(0644,root,root) %{_libdir}/rlm_ns_mta_md5.a

# rlm_pam
%attr(0755,root,root) %{_libdir}/rlm_pam*.la
%attr(0755,root,root) %{_libdir}/rlm_pam*so*
%attr(0644,root,root) %{_libdir}/rlm_pam.a

# rlm_pap
%attr(0755,root,root) %{_libdir}/rlm_pap*.la
%attr(0755,root,root) %{_libdir}/rlm_pap*so*
%attr(0644,root,root) %{_libdir}/rlm_pap.a

# rlm_preprocess
%attr(0755,root,root) %{_libdir}/rlm_preprocess*.la
%attr(0755,root,root) %{_libdir}/rlm_preprocess*so*
%attr(0644,root,root) %{_libdir}/rlm_preprocess.a

# rlm_radutmp
%attr(0755,root,root) %{_libdir}/rlm_radutmp*.la
%attr(0755,root,root) %{_libdir}/rlm_radutmp*so*
%attr(0644,root,root) %{_libdir}/rlm_radutmp.a

# rlm_realm
%attr(0755,root,root) %{_libdir}/rlm_realm*.la
%attr(0755,root,root) %{_libdir}/rlm_realm*so*
%attr(0644,root,root) %{_libdir}/rlm_realm.a

# rlm_sql
# We need to be a little more specific so that RPM doesn't also grab the
# rlm_sql_<driver> modules as well
%attr(0755,root,root) %{_libdir}/rlm_sql-%{version}.la
%attr(0755,root,root) %{_libdir}/rlm_sql-%{version}.so
%attr(0755,root,root) %{_libdir}/rlm_sql.la
%attr(0755,root,root) %{_libdir}/rlm_sql.so
%attr(0644,root,root) %{_libdir}/rlm_sql.a
# sql drivers
# rlm_sql_db2
# rlm_sql_freetds
# rlm_sql_iodbc
# rlm_sql_mysql - divided into a subpackage. see separate %files section
# rlm_sql_oracle
# rlm_sql_postresql
# rlm_sql_sybase
# rlm_sql_unixodbc

# rlm_unix
%attr(0755,root,root) %{_libdir}/rlm_unix*.la
%attr(0755,root,root) %{_libdir}/rlm_unix*so*
%attr(0644,root,root) %{_libdir}/rlm_unix.a

# rlm_x99_token
%attr(0755,root,root) %{_libdir}/rlm_x99_token*.la
%attr(0755,root,root) %{_libdir}/rlm_x99_token*so*
%attr(0644,root,root) %{_libdir}/rlm_x99_token.a

# rlm_ldap
%if %{rlm_ldap}
%files ldap
%attr(0755,root,root) %{_libdir}/rlm_ldap*.la
%attr(0755,root,root) %{_libdir}/rlm_ldap*so*
%attr(0644,root,root) %{_libdir}/rlm_ldap.a
%endif

# rlm_sql_mysql
%if %{rlm_sql_mysql}
%files mysql
%attr(0755,root,root) %{_libdir}/rlm_sql_mysql*.la
%attr(0755,root,root) %{_libdir}/rlm_sql_mysql*so*
%attr(0644,root,root) %{_libdir}/rlm_sql_mysql.a
%endif

# rlm_sql_pgsql
%if %{rlm_sql_pgsql}
%files pgsql
%attr(0755,root,root) %{_libdir}/rlm_sql_postgresql*.la
%attr(0755,root,root) %{_libdir}/rlm_sql_postgresql*so*
%attr(0644,root,root) %{_libdir}/rlm_sql_postgresql.a
%endif

# rlm_unixodbc
%if %{rlm_unixodbc}
%files unixodbc
%attr(0755,root,root) %{_libdir}/rlm_sql_unixodbc*.la
%attr(0755,root,root) %{_libdir}/rlm_sql_unixodbc*so*
%attr(0644,root,root) %{_libdir}/rlm_sql_unixodbc.a
%endif

%changelog
* Sun Jul  4 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-4m)
- stop daemon

* Thu Apr  8 2004 Hiroyuki Koga <kuma@momonga-inux.org>
- (0.9.3-3m)
- correct comment out for _initscriptdir macro
- use %%NoSource and %%make
- add Prereq: chkconfig, initscripts

* Fri Mar 19 2004 Toru Hoshina <t@momonga-linux.org>
- (0.9.3-2m)
- revised spec for enabling rpm 4.2.
- add postgresql and unixodbc support packages.

* Mon Jan 26 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-1m)
- update to 0.9.3

* Tue Nov 18 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (0.9.1-3m)
- add BuildConflicts: db2-devel
- add patch to be compiled with gdbm-1.8.3(libgdbm_compat)
- fix install directory of README.rpm

* Mon Nov 10 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.9.1-2m)
- rebuild against gdbm-1.8.0-19m

* Mon Oct 14 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.9.1-1m)
- version 0.9.1

* Wed Sep  3 2003 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (0.8.1-6m)
- rebuild against for MySQL-4.0.14-1m
- License: GPL
- BuildRoot: %{_tmppath}/%{name}-%{version}-root

* Thu Jun 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-5m)
  rebuild against cyrus-sasl2

* Thu Mar  6 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-4m)
  rebuild against openssl 0.9.7a

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.8.1-3m)
- rebuild against for gdbm

* Sun Feb  9 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.8.1-2m)
- %%install: rm -rf %{buildroot} before install

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-1m)
  update to 0.8.1

* Sun Jan 05 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (0.7.1-2m)
- fix Source URI.

* Fri Nov 01 2002 YAMAGUCHI Kenji <yamk@momonga-linux.org>
- This RPM were created by Shawn K. O'Shea <pkg@eth0.net>
- get from http://volcano.boulderhill.net/freeradius-rpm/
- see http://volcano.boulderhill.net/freeradius-rpm/README.rpm.txt
- Momongized.
- NoSource.
- update to 0.7.1
- enable support mysql and ldap as default
